package net;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class Listener implements Runnable {

    public int     listenPort;

    private String remoteServer;

    private int    remoteServerPort;

    public Listener(int listenPort, String remoteServer, int remoteServerPort) {
        this.listenPort = listenPort;
        this.remoteServer = remoteServer;
        this.remoteServerPort = remoteServerPort;
    }

    public static ExecutorService pool = Executors.newCachedThreadPool();

    public void run() {
        try {
            ServerSocketChannel channel = ServerSocketChannel.open();
            channel.socket().bind(new InetSocketAddress("localhost", listenPort));
            while (true) {
                SocketChannel s = channel.accept();
                pool.execute(new Proxy(s, remoteServer, remoteServerPort));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

}
